// Copyright (C) 2009 EPITA Research and Development Laboratory (LRDE)
//
// This file is part of Olena.
//
// Olena is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation, version 2 of the License.
//
// Olena is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Olena.  If not, see <http://www.gnu.org/licenses/>.
//
// As a special exception, you may use this file as part of a free
// software project without restriction.  Specifically, if other files
// instantiate templates or use macros or inline functions from this
// file, or you compile this file and link it with other files to produce
// an executable, this file does not by itself cause the resulting
// executable to be covered by the GNU General Public License.  This
// exception does not however invalidate any other reasons why the
// executable file might be covered by the GNU General Public License.

#ifndef SCRIBO_PRIMITIVE_INTERNAL_INIT_LINK_ARRAY_HH
# define SCRIBO_PRIMITIVE_INTERNAL_INIT_LINK_ARRAY_HH

/// \file
///
/// Initialize a link array.


# include <mln/util/array.hh>


namespace scribo
{

  using namespace mln;

  namespace primitive
  {

    namespace internal
    {

      /// Initialize a link array.
      void
      init_link_array(mln::util::array<unsigned>& link_array);

# ifndef MLN_INCLUDE_ONLY

      inline
      void
      init_link_array(mln::util::array<unsigned>& link_array)
      {
	for (unsigned i = 0; i < link_array.nelements(); ++i)
	  link_array[i] = i;
      }

# endif // ! MLN_INCLUDE_ONLY

    } // end of namespace scribo::primitive::internal

  } // end of namespace scribo::primitive

} // end of namespace scribo


#endif // ! SCRIBO_PRIMITIVE_INTERNAL_INIT_LINK_ARRAY_HH
